[LeetCode] 948. Bag of Tokens

You have an initial power of P, an initial score of 0, and a bag of tokens where tokens[i] is the value of the ith token (0-indexed).

Your goal is to maximize your total score by potentially playing each token in one of two ways:

  • If your current power is at least tokens[i], you may play the ith token face up, losing tokens[i] power and gaining 1 score.
  • If your current score is at least 1, you may play the ith token face down, gaining tokens[i] power and losing 1 score.

Each token may be played at most once and in any order. You do not have to play all the tokens.

Return the largest possible score you can achieve after playing any number of tokens.

Example 1:

Input: tokens = [100], P = 50
Output: 0
Explanation: Playing the only token in the bag is impossible because you either have too little power or too little score.

Example 2:

Input: tokens = [100,200], P = 150
Output: 1
Explanation: Play the 0th token (100) face up, your power becomes 50 and score becomes 1.
There is no need to play the 1st token since you cannot play it face up to add to your score.

Example 3:

Input: tokens = [100,200,300,400], P = 200
Output: 2
Explanation: Play the tokens in this order to get a score of 2:
1. Play the 0th token (100) face up, your power becomes 100 and score becomes 1.
2. Play the 3rd token (400) face down, your power becomes 500 and score becomes 0.
3. Play the 1st token (200) face up, your power becomes 300 and score becomes 1.
4. Play the 2nd token (300) face up, your power becomes 0 and score becomes 2.

Constraints:

  • 0 <= tokens.length <= 1000
  • 0 <= tokens[i], P < 104

令牌放置。给你一堆令牌,规则是令牌上tokens[i] 代表一个能量值P,每个令牌最多使用一次,使用的方法如下

  • 如果你至少有 token[i] 点能量,可以将令牌置为正面朝上,失去 token[i] 点能量,并得到 1 分。
  • 如果我们至少有 1 分,可以将令牌置为反面朝上,获得 token[i] 点能量,并失去 1 分。

在使用任意数量的令牌后,返回我们可以得到的最大分数。

思路是贪心 + 双指针。将input排序,这样tokens[i]最小的token会在左边,最大的会在右边。设置两个指针从两边往中间逼近,如果当前你的能量P >= tokens[i],说明你有多余的能量,可以拿来换分数;如果不满足这个条件,则需要看看手里目前分数是否 > 0,来换取一个当前最大的能量P(在j指针那里)。

时间O(logn)

空间O(1)

Java实现

 1 class Solution {
 2     public int bagOfTokensScore(int[] tokens, int P) {
 3         int res = 0;
 4         int points = 0;
 5         Arrays.sort(tokens);
 6         int i = 0;
 7         int j = tokens.length - 1;
 8         while (i <= j) {
 9             if (P >= tokens[i]) {
10                 P -= tokens[i++];
11                 points++;
12                 res = Math.max(res, points);
13             } else if (points > 0) {
14                 points--;
15                 P += tokens[j--];
16             } else {
17                 break;
18             }
19         }
20         return res;
21     }
22 }

LeetCode 题目总结

原文地址:https://www.cnblogs.com/cnoodle/p/13876370.html